	.area text(rom,rel)
	.dbfile ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\heap.c
	.area data(ram,rel)
	.dbfile ..\..\..\..\..\ICCPRO~1\nanovm\vm\src\heap.c
	.align	2
_heap_base::
	.word 0
	.dbfile C:\ICCPRO~1\nanovm\vm\src\heap.c
	.dbsym e heap_base _heap_base s
	.area text(rom,rel)
	.dbfile C:\ICCPRO~1\nanovm\vm\src\heap.c
	.dbfunc e heap_get_base _heap_get_base fpc
_heap_get_base::
	.dbline -1
	.dbline 61
; //
; //  NanoVM, a tiny java VM for the Atmel AVR family
; //  Copyright (C) 2005 by Till Harbaum <Till@Harbaum.org>
; //
; //  This program is free software; you can redistribute it and/or modify
; //  it under the terms of the GNU General Public License as published by
; //  the Free Software Foundation; either version 2 of the License, or
; //  (at your option) any later version.
; //
; //  This program is distributed in the hope that it will be useful,
; //  but WITHOUT ANY WARRANTY; without even the implied warranty of
; //  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; //  GNU General Public License for more details.
; //
; //  You should have received a copy of the GNU General Public License
; //  along with this program; if not, write to the Free Software
; //  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
; // 
; 
; //
; //  This file contains the heap. It can be requested to
; //  create/delete objects on the heap and does some
; //  simple garbage collection.
; //
; //  The heap is being used top-to-bottom allowing the
; //  virtual machines stack to grow inside the heap from bottom to
; //  top
; //
; 
; #include "types.h"
; #include "config.h"
; #include "debug.h"
; #include "error.h"
; 
; #include "utils.h"
; #include "heap.h"
; #include "stack.h"
; #include "vm.h"
; 
; u08_t heap[HEAPSIZE];
; u16_t heap_base = 0;
; 
; #define HEAP_ID_FREE 0
; 
; #ifdef P8X32A
; typedef struct {
;   heap_id_t id;
;   unsigned int fieldref:1;
;   unsigned int len:15;
; } heap_t;
; #else
; typedef struct {
;   heap_id_t id;
;   unsigned int fieldref:1;
;   unsigned int len:15;
; } __attribute__((packed)) heap_t;
; #endif
; 
; // return the real heap base (where memory can be "stolen"
; // from
; u08_t *heap_get_base(void) {
	.dbline 62
;   return heap;
	@FLDCNST	
	.long _heap	
	mov R0,TEMP0	
	.dbline -2
L6:
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e heap_memcpy_up _heap_memcpy_up fV
;            len -> R2
;            src -> R1
;            dst -> R0
_heap_memcpy_up::
	@FENTER	
	.long R13,R14,R15,0	
	.dbline -1
	.dbline 67
; }
; 
; // a version of memcpy that can only copy overlapping chunks
; // if the target address is higher
; void heap_memcpy_up(u08_t *dst, u08_t *src, u16_t len) {
	.dbline 68
;   dst += len;  src += len;
	mov R15,R2	
	and R15,MASKFFFF	
	add R15,R0	
	mov R0,R15	
	.dbline 68
	mov R15,R2	
	and R15,MASKFFFF	
	add R15,R1	
	mov R1,R15	
	add PC,#64	;Jump to L9
L8:
	.dbline 69
;   while(len--) *--dst = *--src;
	@FLDCNST	
	.long -1	
	mov R15,TEMP0	
	mov R14,R0	
	add R14,R15	
	mov R14,R14	
	mov R0,R14	
	@FLDCNST	
	.long -1	
	mov R15,TEMP0	
	mov R13,R1	
	add R13,R15	
	mov R13,R13	
	mov R1,R13	
	rdbyte R15,R13	
	wrbyte R15,R14	
L9:
	.dbline 69
	mov R15,R2	
	and R15,MASKFFFF	
	mov R15,R15	WZ
	mov R14,R15	
	sub R14,#1	
	mov R2,R14	
IF_NE	sub PC,#92	;Jump to L8
	.dbline -2
L7:
	@FPOP	
	.long R15,R14,R13,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r len 2 s
	.dbsym r src 1 pc
	.dbsym r dst 0 pc
	.dbend
	.dbfunc e heap_show _heap_show fV
	.dbstruct 0 8 .5
	.dbfield 0 id c
	.dbfield 4 fieldref F[0:1]
	.dbfield 4 len F[1:15]
	.dbend
;              h -> R5
;        current -> R4
_heap_show::
	@FENTER	
	.long R4,R5,R13,R14,R15,0	
	.dbline -1
	.dbline 117
; }
; 
; #ifdef DEBUG_JVM
; // make some sanity checks on the heap in order to detect 
; // heap curruption as early as possible
; void heap_check(void) {
;   u16_t current = heap_base;
;   heap_t *h = (heap_t*)&heap[current];
; 
;   if(h->id != HEAP_ID_FREE) {
;     DEBUGF("heap_check(): start element not free element\n");
;     error(ERROR_HEAP_CORRUPTED);
;   }  
;   
;   current += h->len + sizeof(heap_t);
; 
;   while(current < sizeof(heap)) {
;     h = (heap_t*)&heap[current];
;     if(h->id != HEAP_ID_FREE) {
;       if(h->len > sizeof(heap)) {
; 	DEBUGF("heap_check(): single chunk too big\n");
; 	heap_show();
; 	error(ERROR_HEAP_ILLEGAL_CHUNK_SIZE);
;       }
;     } else {
;       DEBUGF("heap_check(): unexpected free chunk\n");
;       heap_show();
;       error(ERROR_HEAP_CORRUPTED);
;     }
;     
;     if(h->len+sizeof(heap_t) > sizeof(heap) - current) {
;       DEBUGF("heap_check(): total size error\n");
;       heap_show();
;       error(ERROR_HEAP_CORRUPTED);
;     }
; 
;     current += h->len + sizeof(heap_t);
;   }
; 
;   if(current != sizeof(heap)) {
;     DEBUGF("heap_check(): heap sum mismatch\n");
;     heap_show();
;     error(ERROR_HEAP_CORRUPTED);
;   }
; }
; #endif
; 
; void heap_show(void) {
	.dbline 118
;   u16_t current = heap_base;
	@FLOADH	
	.long _heap_base	
	.long R4	
	.dbline 120
; 
;   DEBUGF("Heap:\n");
	add PC,#244	;Jump to L13
L12:
	.dbline 121
;   while(current < sizeof(heap)) {
	.dbline 122
;     heap_t *h = (heap_t*)&heap[current];
	@FLDCNST	
	.long _heap	
	mov R15,TEMP0	
	mov R14,R4	
	and R14,MASKFFFF	
	mov R5,R14	
	add R5,R15	
	.dbline 123
;     if(h->id == HEAP_ID_FREE) {
	rdbyte R15,R5	
	and R15,MASKFF	WZ
IF_NE	add PC,#4	;Jump to L15
	.dbline 123
	.dbline 124
;       DEBUGF("- %d free bytes\n", h->len);
	.dbline 125
;     } else {
	add PC,#60	;Jump to L16
L15:
	.dbline 125
	.dbline 126
;       DEBUGF("- chunk id %x with %d bytes:\n", h->id, h->len);
	.dbline 128
; 
;       if(h->len > sizeof(heap))
	@FLDCNST	
	.long 32767	
	mov R15,TEMP0	
	mov R14,R5	
	add R14,#4	
	rdlong R14,R14	
	shr R14,#1	
	and R14,R15	
	@FLDCNST	
	.long 768	
	cmp R14,TEMP0	WZ WC
IF_BE	add PC,#12	;Jump to L17
	.dbline 129
; 	error(ERROR_HEAP_ILLEGAL_CHUNK_SIZE);
	mov R0,#0	
	@FCALL	
	.long _error	
L17:
	.dbline 131
; 
;       DEBUG_HEXDUMP(h+1, h->len);
	.dbline 132
;     }
L16:
	.dbline 134
; 
;     if(h->len+sizeof(heap_t) > sizeof(heap) - current) {
	mov R15,R4	
	and R15,MASKFFFF	
	@FLDCNST	
	.long 768	
	mov R14,TEMP0	
	sub R14,R15	
	@FLDCNST	
	.long 32767	
	mov R15,TEMP0	
	mov R13,R5	
	add R13,#4	
	rdlong R13,R13	
	shr R13,#1	
	and R13,R15	
	mov R15,R13	
	add R15,#8	
	cmp R15,R14	WZ WC
IF_BE	add PC,#12	;Jump to L19
	.dbline 134
	.dbline 135
;       DEBUGF("heap_show(): total size error\n");
	.dbline 136
;       error(ERROR_HEAP_CORRUPTED);
	mov R0,#1	
	@FCALL	
	.long _error	
	.dbline 137
;     }
L19:
	.dbline 139
; 
;     current += h->len + sizeof(heap_t);
	@FLDCNST	
	.long 32767	
	mov R15,TEMP0	
	mov R14,R5	
	add R14,#4	
	rdlong R14,R14	
	shr R14,#1	
	and R14,R15	
	mov R15,R14	
	add R15,#8	
	mov R14,R4	
	and R14,MASKFFFF	
	add R14,R15	
	mov R4,R14	
	.dbline 140
;   }
L13:
	.dbline 121
	@FLDCNST	
	.long 768	
	mov R15,TEMP0	
	mov R14,R4	
	and R14,MASKFFFF	
	cmp R14,R15	WC
IF_B	rdlong PC,PC	
	.long L12	
	.dbline 142
; 
;   DEBUGF("- %d bytes stolen\n", heap_base);
	.dbline -2
L11:
	@FPOP	
	.long R15,R14,R13,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r h 5 pS[.5]
	.dbsym r current 4 s
	.dbend
	.dbfunc e heap_search _heap_search fpS[.5]
;              h -> R6
;        current -> R4
;             id -> R5
_heap_search::
	@FENTER	
	.long R4,R5,R6,R14,R15,0	
	mov R5,R0	
	.dbline -1
	.dbline 147
; }
; 
; // search for chunk with id in heap and return chunk header
; // address
; heap_t *heap_search(heap_id_t id) {
	.dbline 148
;   u16_t current = heap_base;
	@FLOADH	
	.long _heap_base	
	.long R4	
	add PC,#116	;Jump to L23
L22:
	.dbline 150
; 
;   while(current < sizeof(heap)) {
	.dbline 151
;     heap_t *h = (heap_t*)&heap[current];
	@FLDCNST	
	.long _heap	
	mov R15,TEMP0	
	mov R14,R4	
	and R14,MASKFFFF	
	mov R6,R14	
	add R6,R15	
	.dbline 152
;     if(h->id == id) return h;
	mov R15,R5	
	and R15,MASKFF	
	rdbyte R14,R6	
	and R14,MASKFF	
	cmp R14,R15	WZ
IF_NE	add PC,#8	;Jump to L25
	.dbline 152
	mov R0,R6	
	add PC,#88	;Jump to L21
L25:
	.dbline 153
;     current += h->len + sizeof(heap_t);
	@FLDCNST	
	.long 32767	
	mov R15,TEMP0	
	mov R14,R6	
	add R14,#4	
	rdlong R14,R14	
	shr R14,#1	
	and R14,R15	
	mov R15,R14	
	add R15,#8	
	mov R14,R4	
	and R14,MASKFFFF	
	add R14,R15	
	mov R4,R14	
	.dbline 154
;   }
L23:
	.dbline 150
	@FLDCNST	
	.long 768	
	mov R15,TEMP0	
	mov R14,R4	
	and R14,MASKFFFF	
	cmp R14,R15	WC
IF_B	sub PC,#144	;Jump to L22
	.dbline 155
;   return NULL;
	mov R0,#0	
	.dbline -2
L21:
	@FPOP	
	.long R15,R14,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r h 6 pS[.5]
	.dbsym r current 4 s
	.dbsym r id 5 c
	.dbend
	.dbfunc e heap_new_id _heap_new_id fc
;             id -> R4
_heap_new_id::
	@FENTER	
	.long R4,R15,0	
	.dbline -1
	.dbline 158
; }
; 
; heap_id_t heap_new_id(void) {
	.dbline 161
;   heap_id_t id;
; 
;   for(id=1;id;id++) 
	mov R4,#1	
	add PC,#52	;Jump to L31
L28:
	.dbline 162
;     if(heap_search(id) == NULL) 
	mov R0,R4	
	and R0,MASKFF	
	@FCALL	
	.long _heap_search	
	mov R15,R0	WZ
IF_NE	add PC,#12	;Jump to L32
	.dbline 163
;       return id;
	mov R0,R4	
	and R0,MASKFF	
	add PC,#32	;Jump to L27
L32:
L29:
	.dbline 161
	mov R15,R4	
	and R15,MASKFF	
	add R15,#1	
	mov R4,R15	
L31:
	.dbline 161
	mov R15,R4	
	and R15,MASKFF	WZ
IF_NE	sub PC,#64	;Jump to L28
	.dbline 165
; 
;   return 0;
	mov R0,#0	
	.dbline -2
L27:
	@FPOP	
	.long R15,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r id 4 c
	.dbend
	.dbfunc e heap_alloc_internal _heap_alloc_internal fc
;            req -> R6
;              h -> R4
;           size -> R2
;       fieldref -> R1
;             id -> R5
_heap_alloc_internal::
	@FENTER	
	.long R4,R5,R6,R12,R13,R14,R15,0	
	mov R5,R0	
	.dbline -1
	.dbline 168
; }
; 
; bool_t heap_alloc_internal(heap_id_t id, bool_t fieldref, u16_t size) {
	.dbline 169
;   u16_t req = size + sizeof(heap_t);  // total mem required
	mov R15,R2	
	and R15,MASKFFFF	
	add R15,#8	
	mov R6,R15	
	.dbline 172
; 
;   // search for free block
;   heap_t *h = (heap_t*)&heap[heap_base];
	@FLDCNST	
	.long _heap	
	mov R15,TEMP0	
	@FLOADH	
	.long _heap_base	
	.long R14	
	and R14,MASKFFFF	
	mov R4,R14	
	add R4,R15	
	.dbline 174
; 
;   if(h->len >= req) {
	@FLDCNST	
	.long 32767	
	mov R15,TEMP0	
	mov R14,R4	
	add R14,#4	
	rdlong R14,R14	
	shr R14,#1	
	and R14,R15	
	mov R15,R6	
	and R15,MASKFFFF	
	cmp R14,R15	WC
IF_B	rdlong PC,PC	
	.long L35	
	.dbline 174
	.dbline 176
;     // reduce the size of the free chunk
;     h->len -= req;
	mov R15,R4	
	add R15,#4	
	mov R15,R15	
	rdlong R14,R15	
	@FLDCNST	
	.long 32767	
	mov R13,TEMP0	
	mov R12,R14	
	shr R12,#1	
	and R12,R13	
	mov R13,R6	
	and R13,MASKFFFF	
	sub R12,R13	
	@FLDCNST	
	.long 32767	
	and R12,TEMP0	
	mov R13,R12	
	shl R13,#1	
	@FLDCNST	
	.long 0xfffe	
	and R13,TEMP0	
	@FLDCNST	
	.long 0xffff0001	
	mov R12,TEMP0	
	mov R14,R14	
	and R14,R12	
	or R14,R13	
	wrlong R14,R15	
	.dbline 179
; 
;     // and create the new chunk behind this one
;     h = (heap_t*)&heap[heap_base + sizeof(heap_t) + h->len];
	@FLDCNST	
	.long 32767	
	mov R15,TEMP0	
	mov R14,R4	
	add R14,#4	
	rdlong R14,R14	
	shr R14,#1	
	and R14,R15	
	@FLOADH	
	.long _heap_base	
	.long R15	
	and R15,MASKFFFF	
	add R15,#8	
	add R15,R14	
	@FLDCNST	
	.long _heap	
	mov R14,TEMP0	
	mov R4,R15	
	add R4,R14	
	.dbline 180
;     h->id = id;
	wrbyte R5,R4	
	.dbline 181
;     h->fieldref = fieldref;
	mov R15,R4	
	add R15,#4	
	mov R15,R15	
	@FLDCNST	
	.long 0xfffffffe	
	mov R14,TEMP0	
	rdlong R13,R15	
	and R13,R14	
	mov R14,R1	
	and R14,MASKFF	
	and R14,#1	
	or R13,R14	
	wrlong R13,R15	
	.dbline 182
;     h->len = size;
	mov R15,R4	
	add R15,#4	
	mov R15,R15	
	@FLDCNST	
	.long 32767	
	mov R14,TEMP0	
	mov R13,R2	
	and R13,MASKFFFF	
	and R13,R14	
	mov R14,R13	
	shl R14,#1	
	@FLDCNST	
	.long 0xfffe	
	and R14,TEMP0	
	@FLDCNST	
	.long 0xffff0001	
	mov R13,TEMP0	
	rdlong R12,R15	
	and R12,R13	
	mov R13,R12	
	or R13,R14	
	wrlong R13,R15	
	.dbline 189
; #ifdef NVM_INITIALIZE_ALLOCATED
;     // fill memory with zero
;     u08_t * ptr = (void*)(h+1);
;     while(size--)
;       *ptr++=0;
; #endif
;     return TRUE;
	mov R0,#1	
	add PC,#4	;Jump to L34
L35:
	.dbline 192
;   }
; 
;   DEBUGF("heap_alloc_internal(%d): out of memory\n", size);
	.dbline 193
;   return FALSE;
	mov R0,#0	
	.dbline -2
L34:
	@FPOP	
	.long R15,R14,R13,R12,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r req 6 s
	.dbsym r h 4 pS[.5]
	.dbsym r size 2 s
	.dbsym r fieldref 1 c
	.dbsym r id 5 c
	.dbend
	.dbfunc e heap_alloc _heap_alloc fc
;             id -> R4
;           size -> R5
;       fieldref -> R6
_heap_alloc::
	@FENTER	
	.long R4,R5,R6,R15,0	
	mov R6,R0	
	mov R5,R1	
	.dbline -1
	.dbline 196
; }
; 
; heap_id_t heap_alloc(bool_t fieldref, u16_t size) {
	.dbline 197
;   heap_id_t id = heap_new_id();
	@FCALL	
	.long _heap_new_id	
	mov R15,R0	
	mov R4,R15	
	.dbline 199
; 
;   DEBUGF("heap_alloc(size=%d)", size);
	.dbline 200
;   DEBUGF(" -> id=0x%04x\n", id);
	.dbline 201
;   if(!heap_alloc_internal(id, fieldref, size)) {
	mov R0,R15	
	and R0,MASKFF	
	mov R1,R6	
	and R1,MASKFF	
	mov R2,R5	
	and R2,MASKFFFF	
	@FCALL	
	.long _heap_alloc_internal	
	mov R15,R0	
	and R15,MASKFF	WZ
IF_NE	add PC,#64	;Jump to L38
	.dbline 201
	.dbline 202
;     heap_garbage_collect();
	@FCALL	
	.long _heap_garbage_collect	
	.dbline 204
;     // we need to reallocate heap id, gc. threw away the old one..
;     if(!heap_alloc_internal(id, fieldref, size))
	mov R0,R4	
	and R0,MASKFF	
	mov R1,R6	
	and R1,MASKFF	
	mov R2,R5	
	and R2,MASKFFFF	
	@FCALL	
	.long _heap_alloc_internal	
	mov R15,R0	
	and R15,MASKFF	WZ
IF_NE	add PC,#12	;Jump to L40
	.dbline 205
;       error(ERROR_HEAP_OUT_OF_MEMORY);
	mov R0,#2	
	@FCALL	
	.long _error	
L40:
	.dbline 206
;     DEBUGF("heap_alloc(size=%d)", size);
	.dbline 207
;     DEBUGF(" -> id=0x%04x successfull after gc\n", id);
	.dbline 208
;   }
L38:
	.dbline 210
; 
;   return id;
	mov R0,R4	
	and R0,MASKFF	
	.dbline -2
L37:
	@FPOP	
	.long R15,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r id 4 c
	.dbsym r size 5 s
	.dbsym r fieldref 6 c
	.dbend
	.dbfunc e heap_realloc _heap_realloc fV
;          h_new -> R5
;              h -> R4
;           size -> R7
;             id -> R6
_heap_realloc::
	@FENTER	
	.long R4,R5,R6,R7,R14,R15,0	
	mov R6,R0	
	mov R7,R1	
	.dbline -1
	.dbline 213
; }
; 
; void heap_realloc(heap_id_t id, u16_t size) {
	.dbline 214
;   heap_t *h = 0;
	.dbline 215
;   heap_t *h_new = 0;
	mov R5,#0	
	.dbline 216
;   DEBUGF("heap_realloc(id=0x%04x, size=%d)\n", id, size);
	.dbline 219
; 
;   // check free mem and call garbage collection if required
;   h = (heap_t*)&heap[heap_base];
	@FLDCNST	
	.long _heap	
	mov R15,TEMP0	
	@FLOADH	
	.long _heap_base	
	.long R14	
	and R14,MASKFFFF	
	mov R4,R14	
	add R4,R15	
	.dbline 220
;   if(h->len >= size + sizeof(heap_t))
	@FLDCNST	
	.long 32767	
	mov R15,TEMP0	
	mov R14,R4	
	add R14,#4	
	rdlong R14,R14	
	shr R14,#1	
	and R14,R15	
	mov R15,R7	
	and R15,MASKFFFF	
	add R15,#8	
	cmp R14,R15	WC
IF_B	add PC,#8	;Jump to L43
	.dbline 221
;     heap_garbage_collect();
	@FCALL	
	.long _heap_garbage_collect	
L43:
	.dbline 224
; 
;   // get info on old chunk
;   h = heap_search(id);
	mov R0,R6	
	and R0,MASKFF	
	@FCALL	
	.long _heap_search	
	mov R4,R0	
	.dbline 227
; 
;   // allocate space for bigger one
;   if(!heap_alloc_internal(id, h->fieldref, size))
	mov R0,R6	
	and R0,MASKFF	
	mov R15,R4	
	add R15,#4	
	rdlong R15,R15	
	and R15,#1	
	mov R1,R15	
	and R1,MASKFF	
	mov R2,R7	
	and R2,MASKFFFF	
	@FCALL	
	.long _heap_alloc_internal	
	mov R15,R0	
	and R15,MASKFF	WZ
IF_NE	add PC,#12	;Jump to L45
	.dbline 228
;     error(ERROR_HEAP_OUT_OF_MEMORY);
	mov R0,#2	
	@FCALL	
	.long _error	
L45:
	.dbline 230
; 
;   h_new = heap_search(id);
	mov R0,R6	
	and R0,MASKFF	
	@FCALL	
	.long _heap_search	
	mov R15,R0	
	mov R5,R0	
	.dbline 232
; 
;   utils_memcpy(h_new+1, h+1, h->len);
	mov R0,R15	
	add R0,#8	
	mov R1,R4	
	add R1,#8	
	@FLDCNST	
	.long 32767	
	mov R15,TEMP0	
	mov R14,R4	
	add R14,#4	
	rdlong R14,R14	
	shr R14,#1	
	and R14,R15	
	mov R2,R14	
	and R2,MASKFFFF	
	@FCALL	
	.long _utils_memcpy	
	.dbline 234
; 
;   h->id = 0xff;  // unused id to make garbage collection delete
	mov R15,#255	
	wrbyte R15,R4	
	.dbline -2
L42:
	@FPOP	
	.long R15,R14,R7,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r h_new 5 pS[.5]
	.dbsym r h 4 pS[.5]
	.dbsym r size 7 s
	.dbsym r id 6 c
	.dbend
	.dbfunc e heap_get_len _heap_get_len fs
;              h -> R4
;             id -> R4
_heap_get_len::
	@FENTER	
	.long R4,R14,R15,0	
	mov R4,R0	
	.dbline -1
	.dbline 238
;                  // this chunk next time
; }
; 
; u16_t heap_get_len(heap_id_t id) {
	.dbline 239
;   heap_t *h = heap_search(id);
	mov R0,R4	
	and R0,MASKFF	
	@FCALL	
	.long _heap_search	
	mov R15,R0	
	mov R4,R0	
	.dbline 240
;   if(!h) error(ERROR_HEAP_CHUNK_DOES_NOT_EXIST);
	mov R15,R15	WZ
IF_NE	add PC,#12	;Jump to L48
	.dbline 240
	mov R0,#3	
	@FCALL	
	.long _error	
L48:
	.dbline 241
;   return h->len;
	@FLDCNST	
	.long 32767	
	mov R15,TEMP0	
	mov R14,R4	
	add R14,#4	
	rdlong R14,R14	
	shr R14,#1	
	and R14,R15	
	mov R0,R14	
	and R0,MASKFFFF	
	.dbline -2
L47:
	@FPOP	
	.long R15,R14,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r h 4 pS[.5]
	.dbsym r id 4 c
	.dbend
	.dbfunc e heap_get_addr _heap_get_addr fpV
;              h -> R4
;             id -> R4
_heap_get_addr::
	@FENTER	
	.long R4,R15,0	
	mov R4,R0	
	.dbline -1
	.dbline 244
; }
; 
; void *heap_get_addr(heap_id_t id) {
	.dbline 245
;   heap_t *h = heap_search(id);
	mov R0,R4	
	and R0,MASKFF	
	@FCALL	
	.long _heap_search	
	mov R15,R0	
	mov R4,R0	
	.dbline 246
;   if(!h) error(ERROR_HEAP_CHUNK_DOES_NOT_EXIST);
	mov R15,R15	WZ
IF_NE	add PC,#12	;Jump to L51
	.dbline 246
	mov R0,#3	
	@FCALL	
	.long _error	
L51:
	.dbline 247
;   return h+1;
	mov R0,R4	
	add R0,#8	
	.dbline -2
L50:
	@FPOP	
	.long R15,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r h 4 pS[.5]
	.dbsym r id 4 c
	.dbend
	.dbfunc e heap_init _heap_init fV
;              h -> R0
_heap_init::
	@FENTER	
	.long R13,R14,R15,0	
	.dbline -1
	.dbline 250
; }
; 
; void heap_init(void) {
	.dbline 251
;   heap_t *h = 0; 
	.dbline 252
;   DEBUGF("heap_init()\n");
	.dbline 255
; 
;   // just one big free block
;   h = (heap_t*)&heap[0];
	@FLDCNST	
	.long _heap	
	mov R0,TEMP0	
	.dbline 256
;   h->id  = HEAP_ID_FREE;
	mov R15,#0	
	wrbyte R15,R0	
	.dbline 257
;   h->len = sizeof(heap) - sizeof(heap_t);
	mov R15,R0	
	add R15,#4	
	mov R15,R15	
	@FLDCNST	
	.long 0xffff0001	
	mov R14,TEMP0	
	rdlong R13,R15	
	and R13,R14	
	@FLDCNST	
	.long 1520	
	or R13,TEMP0	
	wrlong R13,R15	
	.dbline -2
L53:
	@FPOP	
	.long R15,R14,R13,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r h 0 pS[.5]
	.dbend
	.dbfunc e heap_fieldref _heap_fieldref fc
;              j -> R7
;              h -> R6
;        current -> R4
;           id16 -> R5
;             id -> R5
_heap_fieldref::
	@FENTER	
	.long R4,R5,R6,R7,R14,R15,0	
	mov R5,R0	
	.dbline -1
	.dbline 266
; }
; 
; // in some cases, references to heap objects may be inside
; // other heap objects. This currently happens only when
; // a class is instanciated and this class contains fields.
; // the heap element created by the constructor is marked with
; // the fieldref bit and it is searched for references during
; // garbage collections
; bool_t heap_fieldref(heap_id_t id) {
	.dbline 267
;   nvm_ref_t id16 = id | NVM_TYPE_HEAP;
	@FLDCNST	
	.long 32768	
	mov R15,TEMP0	
	mov R14,R5	
	and R14,MASKFF	
	or R14,R15	
	mov R5,R14	
	.dbline 268
;   u16_t current = heap_base;
	@FLOADH	
	.long _heap_base	
	.long R4	
	rdlong PC,PC	
	.long L56	
L55:
	.dbline 271
; 
;   // walk through the entire heap
;   while(current < sizeof(heap)) {
	.dbline 272
;     heap_t *h = (heap_t*)&heap[current];
	@FLDCNST	
	.long _heap	
	mov R15,TEMP0	
	mov R14,R4	
	and R14,MASKFFFF	
	mov R6,R14	
	add R6,R15	
	.dbline 275
; 
;     // check for entries with the fieldref flag
;     if(h->fieldref) {
	mov R15,R6	
	add R15,#4	
	rdlong R15,R15	
	test R15,#1	WZ
IF_E	add PC,#152	;Jump to L58
	.dbline 275
	.dbline 280
;       u08_t j;
; 
;       // check all entries in the heap element for
;       // the reference we are searching for
;       for(j=0;j<h->len/sizeof(nvm_ref_t);j++) {
	mov R7,#0	
	add PC,#88	;Jump to L63
L60:
	.dbline 280
	.dbline 281
; 	if(((nvm_ref_t*)(h+1))[j] == id16)
	mov R15,R7	
	and R15,MASKFF	
	mov R0,#2	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	mov R14,R6	
	add R14,#8	
	mov R15,R15	
	add R15,R14	
	rdword R15,R15	
	and R15,MASKFFFF	
	mov R14,R5	
	and R14,MASKFFFF	
	cmp R15,R14	WZ
IF_NE	add PC,#8	;Jump to L64
	.dbline 282
; 	  return TRUE;
	mov R0,#1	
	add PC,#164	;Jump to L54
L64:
	.dbline 283
;       }
L61:
	.dbline 280
	mov R15,R7	
	and R15,MASKFF	
	add R15,#1	
	mov R7,R15	
L63:
	.dbline 280
	@FLDCNST	
	.long 32767	
	mov R15,TEMP0	
	mov R14,R6	
	add R14,#4	
	rdlong R14,R14	
	shr R14,#1	
	and R14,R15	
	mov R15,R14	
	shr R15,#1	
	mov R14,R7	
	and R14,MASKFF	
	cmp R14,R15	WC
IF_B	sub PC,#144	;Jump to L60
	.dbline 284
;     }
L58:
	.dbline 286
; 
;     current += h->len + sizeof(heap_t);
	@FLDCNST	
	.long 32767	
	mov R15,TEMP0	
	mov R14,R6	
	add R14,#4	
	rdlong R14,R14	
	shr R14,#1	
	and R14,R15	
	mov R15,R14	
	add R15,#8	
	mov R14,R4	
	and R14,MASKFFFF	
	add R14,R15	
	mov R4,R14	
	.dbline 287
;   }
L56:
	.dbline 271
	@FLDCNST	
	.long 768	
	mov R15,TEMP0	
	mov R14,R4	
	and R14,MASKFFFF	
	cmp R14,R15	WC
IF_B	rdlong PC,PC	
	.long L55	
	.dbline 289
;   
;   return FALSE;
	mov R0,#0	
	.dbline -2
L54:
	@FPOP	
	.long R15,R14,R7,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r j 7 c
	.dbsym r h 6 pS[.5]
	.dbsym r current 4 s
	.dbsym r id16 5 s
	.dbsym r id 5 c
	.dbend
	.dbfunc e heap_garbage_collect _heap_garbage_collect fV
;            len -> R5
;        current -> R4
;              h -> R6
_heap_garbage_collect::
	@FENTER	
	.long R4,R5,R6,R12,R13,R14,R15,0	
	.dbline -1
	.dbline 294
; }
; 
; // walk through the heap, check for every object
; // if it's still being used and remove it if not
; void heap_garbage_collect(void) {
	.dbline 295
;   u16_t current = heap_base;
	@FLOADH	
	.long _heap_base	
	.long R4	
	.dbline 297
;   heap_t *h;
;   DEBUGF("heap_garbage_collect() free space before: %d\n", ((heap_t*)&heap[heap_base])->len);
	rdlong PC,PC	
	.long L68	
L67:
	.dbline 300
;   // set current to stack-top
;   // walk through the entire heap
;   while(current < sizeof(heap)) {
	.dbline 301
;     u16_t len = 0;
	.dbline 302
;     h = (heap_t*)&heap[current];
	@FLDCNST	
	.long _heap	
	mov R15,TEMP0	
	mov R14,R4	
	and R14,MASKFFFF	
	mov R6,R14	
	add R6,R15	
	.dbline 303
;     len = h->len + sizeof(heap_t);
	@FLDCNST	
	.long 32767	
	mov R15,TEMP0	
	mov R14,R6	
	add R14,#4	
	rdlong R14,R14	
	shr R14,#1	
	and R14,R15	
	mov R15,R14	
	add R15,#8	
	mov R5,R15	
	.dbline 306
; 
;     // found an entry
;     if(h->id != HEAP_ID_FREE) {
	rdbyte R15,R6	
	and R15,MASKFF	WZ
IF_E	rdlong PC,PC	
	.long L70	
	.dbline 306
	.dbline 308
;       // check if it's still used
;       if((!stack_heap_id_in_use(h->id))&&(!heap_fieldref(h->id))) {
	rdbyte R0,R6	
	and R0,MASKFF	
	@FCALL	
	.long _stack_heap_id_in_use	
	mov R15,R0	
	and R15,MASKFF	WZ
IF_NE	rdlong PC,PC	
	.long L72	
	rdbyte R0,R6	
	and R0,MASKFF	
	@FCALL	
	.long _heap_fieldref	
	mov R15,R0	
	and R15,MASKFF	WZ
IF_NE	add PC,#252	;Jump to L72
	.dbline 308
	.dbline 310
; 	// it is not used, remove it
; 	DEBUGF("HEAP: removing unused object with id 0x%04x (len %d)\n",
	.dbline 314
; 	       h->id, len);
;       
; 	// move everything before to the top
; 	heap_memcpy_up(heap+heap_base+len, heap+heap_base, current-heap_base);
	@FLDCNST	
	.long _heap	
	mov R15,TEMP0	
	@FLOADH	
	.long _heap_base	
	.long R14	
	and R14,MASKFFFF	
	mov R14,R14	
	add R14,R15	
	mov R14,R14	
	mov R15,R5	
	and R15,MASKFFFF	
	mov R0,R15	
	add R0,R14	
	mov R1,R14	
	@FLOADH	
	.long _heap_base	
	.long R15	
	and R15,MASKFFFF	
	mov R14,R4	
	and R14,MASKFFFF	
	sub R14,R15	
	mov R2,R14	
	and R2,MASKFFFF	
	@FCALL	
	.long _heap_memcpy_up	
	.dbline 317
; 
; 	// add freed mem to free-chunk
; 	h = (heap_t*)&heap[heap_base];
	@FLDCNST	
	.long _heap	
	mov R15,TEMP0	
	@FLOADH	
	.long _heap_base	
	.long R14	
	and R14,MASKFFFF	
	mov R6,R14	
	add R6,R15	
	.dbline 318
; 	h->len += len;
	mov R15,R6	
	add R15,#4	
	mov R15,R15	
	rdlong R14,R15	
	@FLDCNST	
	.long 32767	
	mov R13,TEMP0	
	mov R12,R14	
	shr R12,#1	
	and R12,R13	
	mov R13,R5	
	and R13,MASKFFFF	
	add R12,R13	
	@FLDCNST	
	.long 32767	
	and R12,TEMP0	
	mov R13,R12	
	shl R13,#1	
	@FLDCNST	
	.long 0xfffe	
	and R13,TEMP0	
	@FLDCNST	
	.long 0xffff0001	
	mov R12,TEMP0	
	mov R14,R14	
	and R14,R12	
	or R14,R13	
	wrlong R14,R15	
	.dbline 319
;       }
L72:
	.dbline 320
;     }
L70:
	.dbline 321
;     current += len;
	mov R15,R5	
	and R15,MASKFFFF	
	mov R14,R4	
	and R14,MASKFFFF	
	add R14,R15	
	mov R4,R14	
	.dbline 322
;   }
L68:
	.dbline 300
	@FLDCNST	
	.long 768	
	mov R15,TEMP0	
	mov R14,R4	
	and R14,MASKFFFF	
	cmp R14,R15	WC
IF_B	rdlong PC,PC	
	.long L67	
	.dbline 324
; 
;   if(current != sizeof(heap)) {
	@FLDCNST	
	.long 768	
	mov R15,TEMP0	
	mov R14,R4	
	and R14,MASKFFFF	
	cmp R14,R15	WZ
IF_E	add PC,#12	;Jump to L74
	.dbline 324
	.dbline 325
;     DEBUGF("heap_garbage_collect(): total size error\n");
	.dbline 326
;     error(ERROR_HEAP_CORRUPTED);
	mov R0,#1	
	@FCALL	
	.long _error	
	.dbline 327
;   }
L74:
	.dbline 328
;   DEBUGF("heap_garbage_collect() free space after: %d\n", ((heap_t*)&heap[heap_base])->len);
	.dbline -2
L66:
	@FPOP	
	.long R15,R14,R13,R12,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r len 5 s
	.dbsym r current 4 s
	.dbsym r h 6 pS[.5]
	.dbend
	.dbfunc e heap_steal _heap_steal fV
;            len -> R4
;              h -> R6
;          bytes -> R5
_heap_steal::
	@FENTER	
	.long R4,R5,R6,R12,R13,R14,R15,0	
	mov R5,R0	
	.dbline -1
	.dbline 333
; }
; 
; // "steal" some bytes from the bottom of the heap (where
; // the free-chunk is)
; void heap_steal(u16_t bytes) {
	.dbline 334
;   heap_t *h = (heap_t*)&heap[heap_base];
	@FLDCNST	
	.long _heap	
	mov R15,TEMP0	
	@FLOADH	
	.long _heap_base	
	.long R14	
	and R14,MASKFFFF	
	mov R6,R14	
	add R6,R15	
	.dbline 337
;   u16_t len;
; 
;   DEBUGF("HEAP: request to steal %d bytes\n", bytes);
	.dbline 339
; 
;   if(h->id != HEAP_ID_FREE) {
	rdbyte R15,R6	
	and R15,MASKFF	WZ
IF_E	add PC,#12	;Jump to L77
	.dbline 339
	.dbline 340
;     DEBUGF("heap_steal(%d): start element not free element\n", bytes);
	.dbline 341
;     error(ERROR_HEAP_CORRUPTED);
	mov R0,#1	
	@FCALL	
	.long _error	
	.dbline 342
;   }
L77:
	.dbline 345
; 
;   // try to make space if necessary
;   len = h->len;
	@FLDCNST	
	.long 32767	
	mov R15,TEMP0	
	mov R14,R6	
	add R14,#4	
	rdlong R14,R14	
	shr R14,#1	
	and R14,R15	
	mov R4,R14	
	.dbline 346
;   if(len < bytes) 
	mov R15,R5	
	and R15,MASKFFFF	
	mov R14,R4	
	and R14,MASKFFFF	
	cmps R14,R15	WC
IF_AE	add PC,#8	;Jump to L79
	.dbline 347
;     heap_garbage_collect();
	@FCALL	
	.long _heap_garbage_collect	
L79:
	.dbline 349
; 
;   len = h->len;
	@FLDCNST	
	.long 32767	
	mov R15,TEMP0	
	mov R14,R6	
	add R14,#4	
	rdlong R14,R14	
	shr R14,#1	
	and R14,R15	
	mov R4,R14	
	.dbline 350
;   if(len < bytes) 
	mov R15,R5	
	and R15,MASKFFFF	
	mov R14,R4	
	and R14,MASKFFFF	
	cmps R14,R15	WC
IF_AE	add PC,#12	;Jump to L81
	.dbline 351
;     error(ERROR_HEAP_OUT_OF_STACK_MEMORY);
	mov R0,#4	
	@FCALL	
	.long _error	
L81:
	.dbline 354
; 
;    // finally steal ...
;   heap_base += bytes;
	mov R15,R5	
	and R15,MASKFFFF	
	@FLOADH	
	.long _heap_base	
	.long R14	
	and R14,MASKFFFF	
	add R14,R15	
	mov R15,R14	
	@FSTOREH	
	.long _heap_base	
	.long R15	
	.dbline 355
;   h = (heap_t*)&heap[heap_base];
	@FLDCNST	
	.long _heap	
	mov R15,TEMP0	
	@FLOADH	
	.long _heap_base	
	.long R14	
	and R14,MASKFFFF	
	mov R6,R14	
	add R6,R15	
	.dbline 356
;   h->id = HEAP_ID_FREE;
	mov R15,#0	
	wrbyte R15,R6	
	.dbline 357
;   h->len = len - bytes;
	mov R15,R6	
	add R15,#4	
	mov R15,R15	
	mov R14,R5	
	and R14,MASKFFFF	
	mov R13,R4	
	and R13,MASKFFFF	
	sub R13,R14	
	mov R14,R13	
	@FLDCNST	
	.long 32767	
	and R14,TEMP0	
	shl R14,#1	
	@FLDCNST	
	.long 0xfffe	
	and R14,TEMP0	
	@FLDCNST	
	.long 0xffff0001	
	mov R13,TEMP0	
	rdlong R12,R15	
	and R12,R13	
	mov R13,R12	
	or R13,R14	
	wrlong R13,R15	
	.dbline -2
L76:
	@FPOP	
	.long R15,R14,R13,R12,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r len 4 s
	.dbsym r h 6 pS[.5]
	.dbsym r bytes 5 s
	.dbend
	.dbfunc e heap_unsteal _heap_unsteal fV
;            len -> R4
;              h -> R6
;          bytes -> R5
_heap_unsteal::
	@FENTER	
	.long R4,R5,R6,R12,R13,R14,R15,0	
	mov R5,R0	
	.dbline -1
	.dbline 361
; }
; 
; // someone wants us to give some bytes back :-)
; void heap_unsteal(u16_t bytes) {
	.dbline 362
;   heap_t *h = (heap_t*)&heap[heap_base];
	@FLDCNST	
	.long _heap	
	mov R15,TEMP0	
	@FLOADH	
	.long _heap_base	
	.long R14	
	and R14,MASKFFFF	
	mov R6,R14	
	add R6,R15	
	.dbline 365
;   u16_t len;
; 
;   if(h->id != HEAP_ID_FREE) {
	rdbyte R15,R6	
	and R15,MASKFF	WZ
IF_E	add PC,#12	;Jump to L84
	.dbline 365
	.dbline 366
;     DEBUGF("heap_unsteal(%d): start element not free element\n", bytes);
	.dbline 367
;     error(ERROR_HEAP_CORRUPTED);
	mov R0,#1	
	@FCALL	
	.long _error	
	.dbline 368
;   }
L84:
	.dbline 370
; 
;   DEBUGF("HEAP: request to unsteal %d bytes\n", bytes);
	.dbline 372
; 
;   if(heap_base < bytes) {
	mov R15,R5	
	and R15,MASKFFFF	
	@FLOADH	
	.long _heap_base	
	.long R14	
	and R14,MASKFFFF	
	cmps R14,R15	WC
IF_AE	add PC,#12	;Jump to L86
	.dbline 372
	.dbline 373
;     DEBUGF("stack underrun by %d bytes\n", bytes-heap_base);
	.dbline 374
;     error(ERROR_HEAP_STACK_UNDERRUN);
	mov R0,#5	
	@FCALL	
	.long _error	
	.dbline 375
;   }
L86:
	.dbline 378
; 
;   // finally unsteal ...
;   len = h->len;
	@FLDCNST	
	.long 32767	
	mov R15,TEMP0	
	mov R14,R6	
	add R14,#4	
	rdlong R14,R14	
	shr R14,#1	
	and R14,R15	
	mov R4,R14	
	.dbline 379
;   heap_base -= bytes;
	mov R15,R5	
	and R15,MASKFFFF	
	@FLOADH	
	.long _heap_base	
	.long R14	
	and R14,MASKFFFF	
	sub R14,R15	
	mov R15,R14	
	@FSTOREH	
	.long _heap_base	
	.long R15	
	.dbline 380
;   h = (heap_t*)&heap[heap_base];
	@FLDCNST	
	.long _heap	
	mov R15,TEMP0	
	@FLOADH	
	.long _heap_base	
	.long R14	
	and R14,MASKFFFF	
	mov R6,R14	
	add R6,R15	
	.dbline 381
;   h->id = HEAP_ID_FREE;
	mov R15,#0	
	wrbyte R15,R6	
	.dbline 382
;   h->len = len + bytes;
	mov R15,R6	
	add R15,#4	
	mov R15,R15	
	mov R14,R5	
	and R14,MASKFFFF	
	mov R13,R4	
	and R13,MASKFFFF	
	add R13,R14	
	mov R14,R13	
	@FLDCNST	
	.long 32767	
	and R14,TEMP0	
	shl R14,#1	
	@FLDCNST	
	.long 0xfffe	
	and R14,TEMP0	
	@FLDCNST	
	.long 0xffff0001	
	mov R13,TEMP0	
	rdlong R12,R15	
	and R12,R13	
	mov R13,R12	
	or R13,R14	
	wrlong R13,R15	
	.dbline -2
L83:
	@FPOP	
	.long R15,R14,R13,R12,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r len 4 s
	.dbsym r h 6 pS[.5]
	.dbsym r bytes 5 s
	.dbend
	.area bss(ram,rel)
	.dbfile C:\ICCPRO~1\nanovm\vm\src\heap.c
_heap::
	.blkb 768
	.dbsym e heap _heap A[768:768]c
